=== debian/changelog ===
minexpert3 (11.0.0-1) unstable; urgency=low

  * New release with entirely new Application preferences configuration
    system.

  * Implemented new vertical rule across plot widgets feature that shows the
    x-axis value when the plots are locked in the x-axis direction.

  * Updates to the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 12 Jan 2026 16:25:16 +0100

minexpert3 (10.3.0-1) unstable; urgency=low

  * New release with reworked QSettings-based configuration and an
    implementation of the 'Recent files... ' menu.

  * Implemented the new mzCbor loader, after new code in libpappsomspp.

  * Reworked, with new code in libpappsomspp, the code on the
    mass spectral combinations. In particular, reinstated the
    data-based binning strategy.

  * Added a new filter to remove all
    the 0-intensity data points from a trace plotted in a plot widget.

  * Depends on more recent libpappsomspp and libxpertmass.

  * Reworked the user manual documentation about the binning strategy.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 18 Dec 2025 20:01:15 +0100

minexpert3 (10.2.0-1) unstable; urgency=low

  * New release with reworked deconvolution processes to always compute
    the mass of the analyte under the mass peak at the start of the mouse
    drag movement.

  * Update to the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 29 Nov 2025 14:38:10 +0100

minexpert3 (10.1.1-1) unstable; urgency=low

  * New release with improved data analysis configuration.

  * Update to the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 22 Nov 2025 00:40:31 +0100

minexpert3 (10.1.0-1) UNRELEASED; urgency=low

  * New release fixing the versioning in the user manual
    user-manual-version-entity.ent file.

  * Updated the user manual with a new section about scripting.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 30 Oct 2025 20:30:36 +0100

minexpert3 (10.0.0-1) UNRELEASED; urgency=low

  * New version of the project ported to the new libXpertMass/libXpertMassGui
    libraries.

 -- Filippo Rusconi <lopippo@debian.org>  Sun, 01 Jun 2025 21:30:05 +0200
