=== debian/watch ===
version=4

# The following page lists the releases
# https://gitlab.com/msxpertsuite/minexpert2/-/tags
# And the actual href in the page is
# href="/msxpertsuite/minexpert3/-/archive/8.1.1/minexpert3-8.1.1.tar.gz"

https://gitlab.com/msxpertsuite/minexpert3/-/tags \
    .*/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
