## minexpert3 11.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 
 project(
     MineXpert3
-    VERSION 11.0.0
+    VERSION 11.1.0
     DESCRIPTION "A program to visualize and explore mass spectrometric data"
     HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert3"
 )
