=== src/CMakeLists.txt ===
--- 
+++ 
@@ -145,9 +145,6 @@
     # The XIC chromatogram feature
     ${GUI_DIR}/XicExtractionWnd.cpp
     #
-    # Analysis preferences
-    ${GUI_DIR}/DiscoveriesPreferencesDlg.cpp
-    #
     # Plot overlay transparent widget and vertical rule slider
     ${GUI_DIR}/PlotAreaOverlay.cpp
     ${GUI_DIR}/VerticalRuleSlider.cpp
@@ -176,6 +173,8 @@
     ${GUI_DIR}/ui/ApplicationPreferencesWndDiscoveriesPageWidget.ui
     ${GUI_DIR}/ui/DecimalPlacesPreferencesWidget.ui
     ${GUI_DIR}/ui/MaxThreadCountPreferencesWidget.ui
+    ${GUI_DIR}/ui/PeakPickingPreferencesWidget.ui
+    ${GUI_DIR}/ui/LowMassDeconvolverPreferencesWidget.ui
 )
 
 set(CMAKE_AUTOUIC_SEARCH_PATHS ${GUI_DIR}/ui)
