=== debian/changelog ===
minexpert3 (11.1.0-2) unstable; urgency=low

  * Fix dependencies on libpappsomspp and libxpertmass.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 21 Feb 2026 21:27:00 +0100

minexpert3 (11.1.0-1) unstable; urgency=low

  * New upstream release implementing a low mass deconvolution feature that
    is accessible from the mass spectrum composite plot widget menu.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 17 Feb 2026 16:48:16 +0100

minexpert3 (11.0.1-1) unstable; urgency=low

   * Bug fix release: now the vertical rule is plotted at the slider position
     with perfect calculation of the x-axis value of the rule position in the
     x-axis-locked plot widgets.

  -- Filippo Rusconi <lopippo@debian.org>  Tue, 13 Jan 2026 14:28:41 +0100
