=== debian/control ===
--- 
+++ 
@@ -21,9 +21,9 @@
  fonts-ebgaramond-extra,
  fonts-urw-base35,
 # Only the logically essential one.
- libpappsomspp-gui-dev (>= 0.11.9),
+ libpappsomspp-gui-dev (>= 0.11.10),
 # Only the logically essential one.
- libxpertmassgui-dev (>= 1.7.1),
+ libxpertmassgui-dev (>= 1.8.1),
  libqscintilla2-qt6-dev,
  libisospec++-dev (>=2.3.1),
  libpwizlite-dev,
